import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/** 
 * The main startup class.
 */
public class Main extends MIDlet
{
	/**
	 * Start app. (or come back from sleep on some phones)
	 */
	public void startApp()
	{
		Res.midlet = this;
		Res.display = Display.getDisplay( this );

		// Start the game
		Displayable d = new GameScreen();
		
		Res.display.setCurrent( d );
	}

	public void pauseApp()
	{
	    trySave();
	}
	
	public void destroyApp( boolean uncond )
	{
	    trySave();
	}

	/**
	 * Tries to save the current on-going game.
	 * NOTE! Works only if the game screen is active.
	 */
	private void trySave()
	{
	    try
	    {
	        Displayable d = Res.display.getCurrent();
	        if ( d instanceof GameScreen )
	            ((GameScreen) d).getStorage().save();
	    }
	    catch ( Throwable t )
	    {
	    }
	}
}
