import javax.microedition.lcdui.*;

/**
 * About screen (for fame and glory).
 */
public class AboutScreen extends Canvas implements CommandListener
{
    private Displayable m_scr_back;
    
    public AboutScreen( Displayable scr_back )
    {
        m_scr_back = scr_back;
        addCommand( new Command( "Back", Command.BACK, 1 ) );
        setCommandListener( this );
    }

    /**
     * Java command listener.
     *  
     * @param c The issued command.
     * @param d The current displayable.
     */
    public void commandAction( Command c, Displayable d )
    {
        Res.display.setCurrent( m_scr_back );
    }
    
    /**
     * The paint method.
     */
    protected void paint( Graphics g )
    {
        int w = getWidth();
        int h = getHeight();
        
        Font f = Font.getDefaultFont();
        int fh = f.getHeight();
        g.setFont( f );
        
        int y = 3;

        g.setColor( 0xffffffff );
        g.fillRect( 0, 0, w, h );
        
        g.setColor( 0xff000000 );
        g.drawString( "FreeDoku v1.0", 3, y, Graphics.LEFT | Graphics.TOP ); y += fh;
        g.drawString( "2005 Jere Sanisalo", 3, y, Graphics.LEFT | Graphics.TOP ); y += fh;
        y += fh;
        g.drawString( "Web:", 3, y, Graphics.LEFT | Graphics.TOP ); y += fh;
        g.drawString( " www.xmunkki.org", 3, y, Graphics.LEFT | Graphics.TOP ); y += fh;
    }
}
