import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;

/**
 * Global resources. 
 */
public class Res
{
    /** The global midlet instance. */
    public static MIDlet midlet;
    /** The global midlet display. */
    public static Display display;
    
    /** The random number generator. */
    public static Random random = new Random();

    
    /**
     * Returns a random integer (0-max).
     * 
     * @param max The maximum value to return.
     * @return The random number.
     */
    public static int randomInt( int max )
    {
        if ( max <= 0 )
            return 0;
        
        return Math.abs( random.nextInt() ) % (max+1);
    }
}
